/**
  ******************************************************************************
  * @file    vk1651_driver.h
  * @author  kevin_guo
  * @version V1.0.0
  * @date    02-01-2018
  * @brief   This file contains all files for vk1651_driver.
  ******************************************************************************
  * @attention
  ******************************************************************************
  */
/* Includes ------------------------------------------------------------------*/	
#include "vk1651_driver.h"	

/* extern variables ----------------------------------------------------------*/
unsigned char keyval;
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
unsigned char vk1651_write_buf[4];
/* Private function prototypes -----------------------------------------------*/
/* Private function ----------------------------------------------------------*/
/*******************************************************************************
* Function Name  : VK1651_delay_nus
* Description    : ʱ1uS
* Input          : n->ʱʱnuS
* Output         : None
* Return         : None
*******************************************************************************/
void VK1651_delay_nus(unsigned int n)	   
{
	unsigned char i;
	while(n--)
	{
		i=10;
		while(i--)
		{//nopָݵƬӦ޸
			__nop();
		}
	}
}	
/*******************************************************************************
* Function Name  : VK1651_delayms
* Description    : ʱ1mS
* Input          : n->ʱʱnmS
* Output         : None
* Return         : None
*******************************************************************************/
void VK1651_delayms(unsigned long int n)
{
	while(n--)
	{
		VK1651_delay_nus(1000);
	}
}

//GPIO ģI2C 
/*******************************************************************************
* Function Name  : VK1651_Start
* Description    : 
* Input          : None 
* Output         : None
* Return         : None
*******************************************************************************/
void VK1651_Start(void)
{
	VK1651_DIO_HIGH;//ͨѶʼǰͨѶ˿ȫʼΪ1	
	VK1651_CLK_HIGH;
	VK1651_delay_nus(2);
	VK1651_DIO_LOW;
	VK1651_CLK_LOW;
	VK1651_delay_nus(1);
}
/*******************************************************************************
* Function Name  : VK1651_Stop
* Description    : 
* Input          : None 
* Output         : None
* Return         : None
*******************************************************************************/
void VK1651_Stop(void)
{
	VK1651_DIO_LOW;
	VK1651_delay_nus(1);
	VK1651_CLK_LOW;
	VK1651_CLK_HIGH;
	VK1651_delay_nus(2);
	VK1651_DIO_HIGH;
	VK1651_delay_nus(1);
}
/*************************************************************
*ƣVK1651_Ack
*ܣVK1651豸Ӧѯ
*
*
*    ע
**************************************************************/
unsigned char VK1651_Ack( void )
{
  unsigned int TimeOut;
  unsigned char RetValue;
  
  VK1651_CLK_LOW;
  VK1651_delay_nus(1);
  VK1651_CLK_HIGH;          //ھŸCLK
  TimeOut = 10000;
  while( TimeOut-- > 0 )  
  {
    if( VK1651_DIO_IO==0 )  //ȡACK
    {
      RetValue = 0;
      break;
    }
    else
    {
      RetValue = 1;
    }
  }  
  return RetValue;
}
/*************************************************************
*ƣVK1651_SendAck
*ܣӦ
*
*
*    ע
**************************************************************/
void VK1651_SendAck( void )
{  
  VK1651_CLK_LOW;
  VK1651_DIO_LOW;
  VK1651_delay_nus(1);
  VK1651_CLK_HIGH;
  VK1651_delay_nus(1);
  VK1651_CLK_LOW;
}
/*******************************************************************************
* Function Name  : VK1651Write1Byte
* Description    : ʱӵͨMCULEDICд1ֽ
* Input          : data8
* Output         : None
* Return         : None
*******************************************************************************/
void VK1651Write1Byte(unsigned char data8)
{
	unsigned char i;
	
	for(i=0;i<8;i++)
	{
		VK1651_CLK_LOW;		//ȽCLK
		if((data8&0x01)!=0)
		{
			VK1651_DIO_HIGH;//Ҫ͵ݵĵλΪ1ѡDIOø
		}
		else
		{
			VK1651_DIO_LOW;	//Ҫ͵ݵĵλΪ0ѡDIO
		}
		VK1651_delay_nus(2);
		VK1651_CLK_HIGH;	//ʱӵ
		VK1651_delay_nus(2);
		data8=data8>>1;		//׼һBIT
	
	}//һֽں˳ѭ
}

/*************************************************************
*ƣVK1651Read1Byte
*ܣһֽ
*
*
*    ע
**************************************************************/
unsigned char VK1651Read1Byte( void )
{
  unsigned char i;
  unsigned char ReadValue = 0;
  unsigned char bit;
	
	VK1651_DIO_HIGH;
	VK1651_delay_nus(2);
  for( i=0; i<8; i++ )
  {
		VK1651_CLK_LOW;
    VK1651_delay_nus(3);
		VK1651_CLK_HIGH;
    if( VK1651_DIO_IO==1 )
      bit = 0X01;
    else
      bit = 0x00;
    VK1651_delay_nus(1);
      
    ReadValue = (ReadValue<<1)|bit;
  }

  return ReadValue;
}
/*******************************************************************************
* Function Name  : Disp_AutoAdd1Addr
* Description    : õַԶһʽַ
* Input          : cmdaddr   дĵַ
*					 			 : databuf   ݻ
*                : num       дݸ
* Output         : None
* Return         : None
*******************************************************************************/
unsigned char VK1651_Disp_AutoAdd1Addr(unsigned char addr,unsigned char* databuf, unsigned char num)
{
	unsigned char i;//iƱҪٸֽʾ	
	
	VK1651_Start();
	VK1651Write1Byte(VK1651_WRDTA_AUTOADD1ADDR);//òõַԶ1ʽдʾݣ
  if( 1 == VK1651_Ack() )
  {
		__nop();
    return 1;
  }
	VK1651_Stop();
	VK1651_Start();
	VK1651Write1Byte(VK1651_STARTADDR+addr);//ʼַ
  if( 1 == VK1651_Ack() )
  {
		__nop();
    return 1;
  }
	//ַ󣬡STBΪ0Ҫʾ
	for(i=0;i<num;i++)
	{
		VK1651Write1Byte(*databuf++);//ʾݹ
		if( 1 == VK1651_Ack() )
		{
		__nop();
			return 1;
		}
	}	
	VK1651_Stop();
	VK1651_Start();
	VK1651Write1Byte(VK1651_DISP_ON|VK1651_PDUTY_10_16);//ʾ
  if( 1 == VK1651_Ack() )
  {
		__nop();
    return 1;
  }
	VK1651_Stop();
	return 0;
}

/*******************************************************************************
* Function Name  : VK1651_Disp_FixedAddr
* Description    : õ̶ַʽַ
* Input          : disa
* Output         : None
* Return         : None
*******************************************************************************/
unsigned char VK1651_Disp_FixedAddr(unsigned char addr, unsigned char data8)
{
	VK1651_Start();
	VK1651Write1Byte(VK1651_WRDTA_FIXEDADDR);//òù̶ַдʾݣ
  if( 1 == VK1651_Ack() )
  {
		__nop();
    return 1;
  }
	VK1651_Stop();
	VK1651_Start();
	VK1651Write1Byte(VK1651_STARTADDR+addr);//ʾݶӦĵַ
  if( 1 == VK1651_Ack() )
  {
		__nop();
    return 1;
  }
	VK1651Write1Byte(data8);//1BYTEʾ
  if( 1 == VK1651_Ack() )
  {
		__nop();
    return 1;
  }
	VK1651_Stop();
	VK1651_Start();
	VK1651Write1Byte(VK1651_DISP_ON|VK1651_PDUTY_12_16);//ʾ
  if( 1 == VK1651_Ack() )
  {
		__nop();
    return 1;
  }
	VK1651_Stop();
	return 0;
}
	
/*************************************************************
*: VK1651ReadKey
*: VK16511ֽ
*: cmd   д
*
*    ע
**************************************************************/
unsigned char VK1651ReadKey(unsigned char cmd)
{	
	unsigned char result;
	
  VK1651_Start();

  VK1651Write1Byte(cmd);
  if( 1 == VK1651_Ack() )
  {
    return 1;
  }
  result=VK1651Read1Byte();
	VK1651_SendAck();
  VK1651_Stop();
 
  return result;
}
/*******************************************************************************
* Function Name  : Vk1651_Init
* Description    : 1651ʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
void VK1651_Init(void)    
{   
	GPIO_SetMode(VK1651_CLK_PORT, VK1651_CLK_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VK1651_DIO_PORT, VK1651_DIO_PIN, GPIO_MODE_QUASI);
	                
	VK1651_CLK_HIGH; 
	VK1651_DIO_HIGH;
}  

/*******************************************************************************
* Function Name  : VK1651_Main
* Description    : 1651Գ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
void VK1651_Main(void)
{   
	unsigned char i,j;
	
	VK1651_Init();
	 
	for(i=0;i<4;i++)
	{
		vk1651_write_buf[i]=0x00;
	}
	VK1651_Disp_AutoAdd1Addr(0,vk1651_write_buf,4);   //4ȫ
	VK1651_delayms(1000); 
	while(1)
	{
	for(i=0;i<4;i++)
	{
		vk1651_write_buf[i]=0x00;
	}
	VK1651_Disp_AutoAdd1Addr(0,vk1651_write_buf,4);   //4ȫ
	VK1651_delayms(1000); 
	for(i=0;i<4;i++)
	{
		vk1651_write_buf[i]=0xff;
	}
	VK1651_Disp_AutoAdd1Addr(0,vk1651_write_buf,4);   //4ȫ
	VK1651_delayms(10); 
	
		VK1651_delayms(1); 
		keyval=VK1651ReadKey(VK1651_CMD_READKEY);
		if(keyval==VK1651_K1SG1)
		{
			for(i=0;i<4;i++)
			{
				vk1651_write_buf[i]=0x7F;
			}
//			VK1651_Disp_AutoAdd1Addr(0,vk1651_write_buf,4);   //4ȫ
			VK1651_Disp_FixedAddr(0,0x7f); //4ȫ
			VK1651_Disp_FixedAddr(1,0x7f);
			VK1651_Disp_FixedAddr(2,0x7f);
			VK1651_Disp_FixedAddr(3,0x7f);
			VK1651_delayms(1000); 
		}
		if(keyval==VK1651_K1SG2)
		{
			for(i=0;i<4;i++)
			{
				vk1651_write_buf[i]=0x00;
			}
//			VK1651_Disp_AutoAdd1Addr(0,vk1651_write_buf,4);   //ȫ
			VK1651_Disp_FixedAddr(0,0x00); //ȫ
			VK1651_Disp_FixedAddr(1,0x00); 
			VK1651_Disp_FixedAddr(2,0x00); 
			VK1651_Disp_FixedAddr(3,0x00); 
			VK1651_delayms(1000); 
		}
//		
		for(j=0;j<4;j++)
		{
			for(i=0;i<4;i++)
			{
				vk1651_write_buf[i]=0x00;
			}
			vk1651_write_buf[j]=0x7f;
			VK1651_Disp_AutoAdd1Addr(0,vk1651_write_buf,4);   //1
			VK1651_delayms(500); 
		}		
		__nop();
	}
}    
/************************END OF FILE****/
