/**
  ******************************************************************************
  * @file    vk1651_driver.h
  * @author  kevin_guo
  * @version V1.0.0
  * @date    07-01-2018
  * @brief   This file contains definitions for vk1651_driver.
  ******************************************************************************
  * @attention
  ******************************************************************************  
  */
#ifndef __VK1651_DRIVER_H__
#define __VK1651_DRIVER_H__

#include "M451Series.h"

/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/
/* Exported macro ------------------------------------------------------------*/
/* Exported define -----------------------------------------------------------*/
#define 	VK1651_CLK_PIN   		BIT0
#define 	VK1651_CLK_PORT  		PA
#define 	VK1651_CLK_IO    		PA0

#define 	VK1651_DIO_PIN   		BIT1
#define 	VK1651_DIO_PORT  		PD
#define 	VK1651_DIO_IO   	 	PD1


#define   VK1651_CLK_HIGH     VK1651_CLK_IO = 1  
#define   VK1651_CLK_LOW      VK1651_CLK_IO = 0  
  
#define   VK1651_DIO_HIGH     VK1651_DIO_IO = 1  
#define   VK1651_DIO_LOW      VK1651_DIO_IO = 0   
 

#define   VK1651_STARTADDR			0xC0 

#define   VK1651_WRDTA_AUTOADD1ADDR   0x40  
#define   VK1651_WRDTA_FIXEDADDR     	0x44   
#define   VK1651_CMD_READKEY     			0x46//0x42  

#define 	VK1651_DISP_ON        0X88  //ʾ
#define 	VK1651_DISP_OFF		   	0x80  //ʾ  
/*0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f ֱӦ
1/16,  2/16,  4/16,  10/16, 11/16, 12/16, 13/16, 14/16  */ 
#define 	VK1651_PDUTY_1_16      0X80  //ʾΪ1/16  
#define 	VK1651_PDUTY_2_16      0X81  //ʾΪ2/16  
#define 	VK1651_PDUTY_4_16      0X82  //ʾΪ4/16  
#define 	VK1651_PDUTY_10_16     0X83  //ʾΪ10/16  
#define 	VK1651_PDUTY_11_16     0X84  //ʾΪ11/16  
#define 	VK1651_PDUTY_12_16     0X85  //ʾΪ12/16  
#define 	VK1651_PDUTY_13_16     0X86  //ʾΪ13/16  
#define 	VK1651_PDUTY_14_16     0X87  //ʾΪ14/16  
//KEY
#define 	VK1651_NOKEY      0xFF  
#define 	VK1651_K1SG1      0xEF   
#define 	VK1651_K1SG2      0x6F  
#define 	VK1651_K1SG3      0xAF  
#define 	VK1651_K1SG4      0x2F  
#define 	VK1651_K1SG5      0xCF  
#define 	VK1651_K1SG6      0x4F  
#define 	VK1651_K1SG7      0x8F  
/* Exported functions ------------------------------------------------------- */
void VK1651_Init(void);  
unsigned char VK1651_Disp_AutoAdd1Addr(unsigned char addr,unsigned char* databuf, unsigned char num);
unsigned char VK1651_Disp_FixedAddr(unsigned char addr, unsigned char data8);
unsigned char VK1651ReadKey(unsigned char cmd);
void  VK1651_Main(void);
#endif  /*__VK1651_DRIVER_H__*/

/************************END OF FILE****/
